/*****

File: nrutil.h
--------------
Memory allocation routines from Numerical Recipes

*****/


#ifndef _nrutil_h
#define _nrutil_h

#define SQR(a) ((sqrarg=(a)) == 0.0 ? 0.0 : sqrarg*sqrarg)

#define MIN(A, B) (A < B ? A : B)
#define MAX(A, B) (A > B ? A : B)

void nrerror(char error_text[]);

int *ivector(int nl, int nh);

unsigned long *lvector(int nl, int nh);

double *dvector(int nl, int nh);

double **dmatrix(int nrl, int nrh, int ncl, int nch);

void free_ivector(int *v, int nl, int nh);

void free_lvector(long *v, int nl, int nh);

void free_dvector(double *v, int nl, int nh);

void free_dmatrix(double **m, int nrl, int nrh, int ncl, int nch);

#endif /* nrutil.h */

