/*****

File: random.h
--------------
Library package for generation of random numbers

*****/

#ifndef _random_h
#define _random_h

#include "vector.h"

/* Function: Mother
   ---------------
   Marsaglia's "The mother of all random number generators" ; 
   C code from a posting of Bob Wheeler.
*/

double Mother(unsigned long *pSeed);
int gengeo(double p);
VectorDouble runif(int n, double low = 0, double high = 1);
VectorDouble rtriangle(int n, double low = 0, double high  = 1);
VectorDouble rtriangleInv(int n, double low = 0, double high = 1);
VectorDouble rtriangleSkew(int n, double low = 0, double high = 1);
int MotherInt(int low, int high, unsigned long *pSeed);
VectorInt rint(int n, double low, double high);
VectorDouble rlogist(int n, double mu, double sigma);
VectorDouble rnorm(int n, double mu, double sigma);
VectorDouble rnorm(int n);
VectorDouble rnormMult(int n);
VectorDouble rbeta(int n, double a, double b);
VectorDouble rpareto(int n, double a);
VectorDouble rparetoMean0(int n, double a);
VectorDouble rparetoSym(int n, double a);
VectorDouble rt3(int n);  // ???
VectorDouble rtwo(int n, double x1, double x2, double p1);
VectorDouble rtwoA(int n, double x1, double x2);


void Sample_with(double *x, int n, double *x_sample, int b, unsigned long *pSeed);

void Sample_without(double *x, int n, double *x_sample, int b,
                    unsigned long *pSeed);

VectorInt sample(const VectorInt &x, int b, int with);                    
VectorDouble sample(const VectorDouble &x, int b, int with);
void sample(const VectorDouble &x, VectorDouble &xSample, int with);

#endif /* random.h */



