
/*****

File: sort.h
------------
Library package to sort all kinds of stuff

*****/

#ifndef _sort_h
#define _sort_h

#include "vector.h"

/* Function: sort
   --------------
   sorts an array of doubles ra[0..n-1] in ascending order using sort.c 
   from NumRep
*/

void sort(double *ra, int n);

void sort(int *ra, int n);

/* Function: sort_two
   ------------------
   sorts an array of doubles ra1[0..n-1] and ra2[0..n-1] in ascending 
   order of ra1, i.e., in S language ra1_ra1[order(ra1)], ra2_ra2[order(ra1)]
*/

void sort_two(double *ra1, double *ra2, int n);

VectorDouble sort(const VectorDouble &x);
VectorInt sort(const VectorInt &x);

VectorInt order(const VectorDouble &x);

#endif /* sort.h */
