/*****

Prototype Header File
Project Joe

*****/

#ifndef _statfcts_h
#define _statfcts_h

#include "vector.h"
#include "matrix.h"

double unity(double *x, int n);   /* returns 1.0 */
double unity(const VectorDouble &x);
double sum(double *x, int n);
//double sum(int n, VectorDouble x);
double sum(const VectorDouble &x);
double prod(const VectorDouble &x);
int sum(const VectorInt &x);
int prod(const VectorInt &x);
double mean(double *x, int n);
double mean(const VectorDouble &x);
double square_mean(double *x, int n);
double meanSquare(const VectorDouble &x);
double median(double *x, int n);
double median(const VectorDouble &x);
double var(double *x, int n);
double var(const VectorDouble &x);
MatrixDouble var(const MatrixDouble &x, int byCol = 1);
MatrixDouble cor(const MatrixDouble &x, int byCol = 1);
double sd(double *x, int n);
double sd(const VectorDouble &x);
VectorDouble CLT(const VectorDouble &x, double alpha);
double norm_euclid(double *x, int n);
double norm_sup(double *x, int n);
double self_norm_sum_sd(double *x, int n);
double conf_stable(double *x, int n);
double variance_ratio_robust(double *x, int n);
double variance_ratio_robust_flex(double *x, int n, int q);
double V_hat_q(double *x, int n, int q);
double tilt_log(double x);

double ar1_fit(double *x, int n);
double ar1_fit_sd(double *x, int n);
double ar1_fit_bc(double *x, int n);
double ar1_inter_fit(double *x, int n);
double ar1_inter_fit_sd(double *x, int n);
VectorDouble linefit(const VectorDouble &x, const VectorDouble &y, int intercept = 1);
VectorDouble linefitSS(const VectorDouble &x, const VectorDouble &y, int intercept = 1);
void svdfit(double **x, double *y, double *a, int ndata, int ma,
            double **u, double **v, double *w);
void svdfit_compact(double **x, double *y, double *a, int ndata, int ma);
void svdvar(double **v, int ma, double *w, double **cvm);
void svdfit1(double **x, double *y, double *a, int ndata, int ma);
double svdfit_one_beta(double **x, double *y, int ndata, int ma, int beta_index);
void svdfit_sd_one_beta(double **x, double *y, int ndata, int ma,
                        int beta_index, double *res);
VectorDouble svdfit(const MatrixDouble &xMat, const VectorDouble &yVec);
VectorDouble svdfitSigma(const MatrixDouble &xMat, const VectorDouble &yVec);
MatrixDouble svdfitFull(const MatrixDouble &xMat, const VectorDouble &yVec);
MatrixDouble VAR1(const MatrixDouble &x, int addInt = 0);
MatrixDouble VAR1_SVD(const MatrixDouble &x);
MatrixDouble VAR1_Resid(const MatrixDouble &x, const MatrixDouble &A);
double VAR1_SVD(const VectorDouble &x);
VectorDouble LUfit(const MatrixDouble &x, const VectorDouble &y, int sigma = 1);
MatrixDouble LUfitFull(const MatrixDouble &x, const VectorDouble &y);

void svdcmp(double **a, int m, int n, double *w, double **v);   // check disabled !!!!!!
void ludcmp(double **a, int n, int *indx, double *d);
void lubksb(double **a, int n, int *indx, double b[]);

#endif /* statfcts.h */
